# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ChatCitation(pydantic.BaseModel):
    """
    A section of the generated reply which cites external knowledge.
    """

    start: int = pydantic.Field(
        description=(
            "The index of text that the citation starts at, counting from zero. For example, a generation of `Hello, world!` with a citation on `world` would have a start value of `7`. This is because the citation starts at `w`, which is the seventh character.\n"
        )
    )
    end: int = pydantic.Field(
        description=(
            "The index of text that the citation ends after, counting from zero. For example, a generation of `Hello, world!` with a citation on `world` would have an end value of `11`. This is because the citation ends after `d`, which is the eleventh character.\n"
        )
    )
    text: str = pydantic.Field(
        description=(
            "The text of the citation. For example, a generation of `Hello, world!` with a citation of `world` would have a text value of `world`.\n"
        )
    )
    document_ids: typing.List[str] = pydantic.Field(
        description=("Identifiers of documents cited by this section of the generated reply.\n")
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
